diff --git a/yum/yumRepo.py b/yum/yumRepo.py
index e5e9ece..4d64dff 100644
--- a/yum/yumRepo.py
+++ b/yum/yumRepo.py
@@ -20,10 +20,12 @@ import time
 import types
 import urlparse
 urlparse.uses_fragment.append("media")
+import urllib
 
 import Errors
 from urlgrabber.grabber import URLGrabber
 from urlgrabber.grabber import default_grabber
+from urlgrabber.progress import format_number
 import urlgrabber.mirror
 from urlgrabber.grabber import URLGrabError
 import repoMDObject
@@ -35,6 +37,7 @@ import sqlitesack
 from yum import config
 from yum import misc
 from yum import comps
+from yum import _
 from constants import *
 import metalink
 
@@ -49,15 +52,54 @@ import stat
 import errno
 import tempfile
 
-#  If you want yum to _always_ check the MD .sqlite files then set this to
-# False (this doesn't affect .xml files or .sqilte files derived from them).
-# With this as True yum will only check when a new repomd.xml or
-# new MD is downloaded.
-#  Note that with atomic MD, we can't have old MD lying around anymore so
-# the only way we need this check is if someone does something like:
-#   cp primary.sqlite /var/cache/yum/blah
-# ...at which point you lose.
-skip_old_DBMD_check = True
+# This is unused now, probably nothing uses it but it was global/public.
+skip_old_DBMD_check = False
+
+try:
+    import xattr
+    if not hasattr(xattr, 'get') or not hasattr(xattr, 'set'):
+        xattr = None # This is a "newer" API.
+except ImportError:
+    xattr = None
+
+#  The problem we are trying to solve here is that:
+#
+# 1. We rarely want to be downloading MD/pkgs/etc.
+# 2. We want to check those files are valid (match checksums) when we do
+#    download them.
+# 3. We _really_ don't want to checksum all the files every time we
+#    run (100s of MBs).
+# 4. We can continue to download files from bad mirrors, or retry files due to
+#    C-c etc.
+#
+# ...we used to solve this by just checking the file size, and assuming the
+# files had been downloaded and checksumed as correct if that matched. But that
+# was error prone on bad mirrors, so now we store the checksum in an
+# xattr ... this does mean that if you can't store xattrs (Eg. NFS) you will
+# rechecksum everything constantly.
+
+def _xattr_get_chksum(filename, chktype):
+    if not xattr:
+        return None
+
+    try:
+        ret = xattr.get(filename, 'user.yum.checksum.' + chktype)
+    except: # Documented to be "EnvironmentError", but make sure
+        return None
+
+    return ret
+
+def _xattr_set_chksum(filename, chktype, chksum):
+    if not xattr:
+        return None
+
+    try:
+        xattr.set(filename, 'user.yum.checksum.' + chktype, chksum)
+    except:
+        return False # Data too long. = IOError ... ignore everything.
+
+    return True
+
 
 warnings.simplefilter("ignore", Errors.YumFutureDeprecationWarning)
 
@@ -103,8 +145,9 @@ class YumPackageSack(packageSack.PackageSack):
         elif datatype in ['filelists', 'otherdata']:
             if repo in self.added:
                 if 'metadata' not in self.added[repo]:
-                    raise Errors.RepoError, '%s md for %s imported before primary' \
-                           % (datatype, repo.id)
+                    raise Errors.RepoError('%s md for %s imported before primary' \
+                           % (datatype, repo.ui_id),
+                                           repo=self)
             current = 0
             for pkgid in dataobj:
                 current += 1
@@ -121,6 +164,26 @@ class YumPackageSack(packageSack.PackageSack):
             # umm, wtf?
             pass
 
+    def _retrieve_async(self, repo, data):
+        """ Just schedule the metadata downloads """
+
+        for item in data:
+            if item in self.added.get(repo, []):
+                continue
+            if item == 'metadata':
+                mydbtype = 'primary_db'
+            elif item == 'filelists':
+                mydbtype = 'filelists_db'
+            elif item == 'otherdata':
+                mydbtype = 'other_db'
+            else:
+                continue
+
+            if self._check_db_version(repo, mydbtype):
+                if not self._check_uncompressed_db_gen(repo, mydbtype):
+                    # NOTE: No failfunc.
+                    repo._retrieveMD(mydbtype, async=True, failfunc=None)
+
     def populate(self, repo, mdtype='metadata', callback=None, cacheonly=0):
         if mdtype == 'all':
             data = ['metadata', 'filelists', 'otherdata']
@@ -138,8 +201,6 @@ class YumPackageSack(packageSack.PackageSack):
                 if item in self.added[repo]:
                     continue
 
-            db_fn = None
-
             if item == 'metadata':
                 mydbtype = 'primary_db'
                 mymdtype = 'primary'
@@ -162,25 +223,41 @@ class YumPackageSack(packageSack.PackageSack):
                 continue
 
             if self._check_db_version(repo, mydbtype):
-                # see if we have the uncompressed db and check it's checksum vs the openchecksum
-                # if not download the compressed file
-                # decompress it
-                # unlink it
+                #  Use gen decompression on DB files. Keeps exactly what we
+                # downloaded in the download dir.
 
+                # Backwards compat. ... try the old uncompressed version first.
                 db_un_fn = self._check_uncompressed_db(repo, mydbtype)
                 if not db_un_fn:
+                    db_un_fn = self._check_uncompressed_db_gen(repo, mydbtype)
+
+                if not db_un_fn:
                     db_fn = repo._retrieveMD(mydbtype)
                     if db_fn:
-                        if not repo.cache:
-                            db_un_fn = misc.decompress(db_fn)
-                            misc.unlink_f(db_fn)
-                            db_un_fn = self._check_uncompressed_db(repo, mydbtype)
+                        # unlink the decompressed file, we know it's not valid
+                        misc.unlink_f(repo.cachedir +'/gen/%s.sqlite' % mydbtype)
+                        db_un_fn = self._check_uncompressed_db_gen(repo,
+                                                                   mydbtype)
+                    if not db_un_fn: # Shouldn't happen?
+                        raise Errors.RepoError('%s: Check uncompressed DB failed' % repo,
+                                               repo=self)
 
                 dobj = repo.cacheHandler.open_database(db_un_fn)
 
             else:
                 repo._xml2sqlite_local = True
+                # Download...
                 xml = repo_get_function()
+
+                #  Use generated dir. and handle compression types metadata
+                # parser doesn't understand.
+                gen = mymdtype + '.xml'
+                ret = misc.repo_gen_decompress(xml, gen, cached=repo.cache)
+                if not ret:
+                    raise Errors.RepoError('%s: Decompress DB failed' % repo,
+                                           repo=self)
+                xml = ret
+                # Convert XML => .sqlite
                 xmldata = repo.repoXML.getData(mymdtype)
                 (ctype, csum) = xmldata.checksum
                 dobj = repo_cache_function(xml, csum)
@@ -193,6 +270,25 @@ class YumPackageSack(packageSack.PackageSack):
         # get rid of all this stuff we don't need now
         del repo.cacheHandler
 
+    def _check_uncompressed_db_gen(self, repo, mdtype):
+        """return file name of db in gen/ dir if good, None if not"""
+
+        mydbdata         = repo.repoXML.getData(mdtype)
+        (r_base, remote) = mydbdata.location
+        fname            = os.path.basename(remote)
+        compressed_fn    = repo.cachedir + '/' + fname
+        db_un_fn         = mdtype + '.sqlite'
+
+        if not repo._checkMD(compressed_fn, mdtype, data=mydbdata,
+                             check_can_fail=True):
+            return None
+
+        ret = misc.repo_gen_decompress(compressed_fn, db_un_fn,
+                                       cached=repo.cache)
+        if ret:
+            return self._check_uncompressed_db_fn(repo, mdtype, ret)
+        return None
+
     def _check_uncompressed_db(self, repo, mdtype):
         """return file name of uncompressed db is good, None if not"""
         mydbdata = repo.repoXML.getData(mdtype)
@@ -201,12 +297,13 @@ class YumPackageSack(packageSack.PackageSack):
         compressed_fn = repo.cachedir + '/' + fname
         db_un_fn = misc.decompress(compressed_fn, fn_only=True)
 
+        return self._check_uncompressed_db_fn(repo, mdtype, db_un_fn)
+
+    def _check_uncompressed_db_fn(self, repo, mdtype, db_un_fn):
         result = None
 
-        repo._preload_md_from_system_cache(os.path.basename(db_un_fn))
         if os.path.exists(db_un_fn):
-            if skip_old_DBMD_check and repo._using_old_MD:
-                return db_un_fn
+
 
             try:
                 repo.checkMD(db_un_fn, mdtype, openchecksum=True)
@@ -240,7 +337,6 @@ class YumRepository(Repository, config.RepoConf):
                                               # eventually want
         self.repoMDFile = 'repodata/repomd.xml'
         self._repoXML = None
-        self._using_old_MD = None
         self._oldRepoMDData = {}
         self.cache = 0
         self.mirrorlistparsed = 0
@@ -260,10 +356,11 @@ class YumRepository(Repository, config.RepoConf):
         self.copy_local = 0
         # holder for stuff we've grabbed
         self.retrieved = { 'primary':0, 'filelists':0, 'other':0, 'group':0,
-                           'updateinfo':0, 'prestodelta' : 0}
+                           'updateinfo':0, 'prestodelta':0}
 
         # callbacks
         self.callback = None  # for the grabber
+        self.multi_callback = None
         self.failure_obj = None
         self.mirror_failure_obj = None
         self.interrupt_callback = None
@@ -285,6 +382,7 @@ class YumRepository(Repository, config.RepoConf):
 
         self._grabfunc = None
         self._grab = None
+        self._async = False
 
     def __cmp__(self, other):
         """ Sort yum repos. by cost, and then by alphanumeric on their id. """
@@ -311,6 +409,36 @@ class YumRepository(Repository, config.RepoConf):
         return self._sack
     sack = property(_getSack)
 
+    def _ui_id(self):
+        """ Show self.id, but include any $releasever/$basearch/etc. data. """
+        if hasattr(self, '__cached_ui_id'):
+            return getattr(self, '__cached_ui_id')
+
+        val = config._readRawRepoFile(self)
+        if not val:
+            val = ''
+        else:
+            ini, section_id = val
+            ini = ini[section_id]
+            if 'metalink' in ini:
+                val = ini['metalink']
+            elif 'mirrorlist' in ini:
+                val = ini['mirrorlist']
+            elif 'baseurl' in ini:
+                val = ini['baseurl']
+            else:
+                val = ''
+        ret = self.id
+
+        for var in self.ui_repoid_vars:
+            if '$'+var in val:
+                ret += '/'
+                ret += str(self.yumvar[var])
+
+        setattr(self, '__cached_ui_id', ret)
+        return ret
+    ui_id = property(_ui_id)
+
     def close(self):
         if self._sack is not None:
             self.sack.close()
@@ -350,6 +478,10 @@ class YumRepository(Repository, config.RepoConf):
         return thisdata.location
 
     def __str__(self):
+        # Note: You might expect this to be .ui_id, except people got used to
+        # the fact that str(repo) == repo.id and used the former instead of
+        # the later when they wanted just the .id. So we have to live with it
+        # and use .ui_id explicitly.
         return self.id
 
     def _checksum(self, sumtype, file, CHUNK=2**16, checksum_can_fail=False,
@@ -363,7 +495,8 @@ class YumRepository(Repository, config.RepoConf):
         except (Errors.MiscError, EnvironmentError), e:
             if checksum_can_fail:
                 return None
-            raise Errors.RepoError, 'Error opening file for checksum: %s' % e
+            raise Errors.RepoError('Error opening file for checksum: %s' % e,
+                                   repo=self)
 
     def dump(self):
         output = '[%s]\n' % self.id
@@ -378,7 +511,7 @@ class YumRepository(Repository, config.RepoConf):
                         'basecachedir', 'http_headers', 'metadata_cookie',
                         'metadata_cookie_fn', 'quick_enable_disable',
                         'repoMDFile', 'timestamp_check', 'urls', 'mirrorurls',
-                        'yumvar', 'repofile')
+                        'yumvar', 'repofile', 'multi_callback')
         for attr in dir(self):
             if attr.startswith('_'):
                 continue
@@ -421,8 +554,8 @@ class YumRepository(Repository, config.RepoConf):
         """self-check the repo information  - if we don't have enough to move
            on then raise a repo error"""
         if len(self._urls) < 1 and not self.mediaid:
-            raise Errors.RepoError, \
-             'Cannot find a valid baseurl for repo: %s' % self.id
+            raise Errors.RepoError('Cannot find a valid baseurl for repo: %s' %
+                                   self.ui_id, repo=self)
 
     def doProxyDict(self):
         if self._proxy_dict:
@@ -431,25 +564,18 @@ class YumRepository(Repository, config.RepoConf):
         self._proxy_dict = {} # zap it
         proxy_string = None
         empty = (None, '_none_', '')
-        if self.proxy not in empty:
+        if self.proxy is None:  # got 'proxy=_none_'
+            proxy_string = ''   # this disables default proxies
+        elif self.proxy:
             proxy_string = '%s' % self.proxy
             if self.proxy_username not in empty:
-                proxy_parsed = urlparse.urlsplit(self.proxy, allow_fragments=0)
-                proxy_proto = proxy_parsed[0]
-                proxy_host = proxy_parsed[1]
-                # http://foo:123 == ('http', 'foo:123', '', '', '')
-                # don't turn that into: http://foo:123? - bug#328121
-                if proxy_parsed[2] == '':
-                    proxy_rest = ''
-                else:
-                    proxy_rest = proxy_parsed[2] + '?' + proxy_parsed[3]
-                proxy_string = '%s://%s@%s%s' % (proxy_proto,
-                        self.proxy_username, proxy_host, proxy_rest)
 
+                auth = urllib.quote(self.proxy_username)
                 if self.proxy_password not in empty:
-                    proxy_string = '%s://%s:%s@%s%s' % (proxy_proto,
-                              self.proxy_username, self.proxy_password,
-                              proxy_host, proxy_rest)
+                    auth += ':' + urllib.quote(self.proxy_password)
+
+                proto, rest = re.match('(\w+://)(.+)', proxy_string).groups()
+                proxy_string = '%s%s@%s' % (proto, auth, rest)
 
         if proxy_string is not None:
             self._proxy_dict['http'] = proxy_string
@@ -483,22 +609,63 @@ class YumRepository(Repository, config.RepoConf):
 
         ugopts = self._default_grabopts()
         self._grabfunc = URLGrabber(progress_obj=self.callback,
+                                    multi_progress_obj=self.multi_callback,
                                     failure_callback=self.failure_obj,
                                     interrupt_callback=self.interrupt_callback,
                                     copy_local=self.copy_local,
                                     reget='simple',
                                     **ugopts)
-
-        self._grab = mgclass(self._grabfunc, self.urls,
-                             failure_callback=self.mirror_failure_obj)
+        def add_mc(url):
+            host = urlparse.urlsplit(url).netloc.split('@')[-1]
+            mc = self.metalink_data._host2mc.get(host)
+            if mc:
+                url = {
+                    'mirror': misc.to_utf8(url),
+                    'kwargs': {
+                        'max_connections': mc.max_connections,
+                        'preference': mc.preference,
+                        'private': mc.private,
+                    },
+                }
+            return url
+        urls = self.urls
+        if self.metalink:
+            urls = map(add_mc, urls)
+
+        def mirror_failure(obj):
+            action = {}
+
+            # timeout, refused connect, and HTTP 503 may retry
+            e = obj.exception
+            if e.errno == 12 or \
+               e.errno == 14 and getattr(e, 'code', 0) in (7, 503):
+                tries = getattr(obj, 'tries', self.retries)
+                if tries <= self.retries - len(self.urls):
+                    # don't remove this mirror yet
+                    action['remove'] = False
+            elif e.errno == -3:
+                # unsupported checksum type, fail now
+                action['fail'] = True
+
+            # No known user of this callback, but just in case...
+            cb = self.mirror_failure_obj
+            if cb:
+                fun, arg, karg = callable(cb) and (cb, (), {}) or cb
+                action.update(fun(obj, *arg, **karg))
+
+            return action
+
+        self._grab = mgclass(self._grabfunc, urls,
+                             failure_callback=mirror_failure)
 
     def _default_grabopts(self, cache=True):
         opts = { 'keepalive': self.keepalive,
                  'bandwidth': self.bandwidth,
                  'retry': self.retries,
                  'throttle': self.throttle,
-                 'proxies': self.proxy_dict,
                  'timeout': self.timeout,
+                 'minrate': self.minrate,
+                 'ip_resolve': self.ip_resolve,
                  'http_headers': tuple(self.__headersListFromDict(cache=cache)),
                  'ssl_verify_peer': self.sslverify,
                  'ssl_verify_host': self.sslverify,
@@ -509,6 +676,10 @@ class YumRepository(Repository, config.RepoConf):
                  'username': self.username,
                  'password': self.password,
                  }
+        if self.proxy == 'libproxy':
+            opts['libproxy'] = True
+        else:
+            opts['proxies'] = self.proxy_dict
         return opts
 
     def _getgrabfunc(self):
@@ -531,15 +702,12 @@ class YumRepository(Repository, config.RepoConf):
         if os.path.exists(dpath) and os.path.isdir(dpath):
             return
 
-        if self.cache:
-            raise Errors.RepoError, "Cannot access repository dir %s" % dpath
-
         try:
             os.makedirs(dpath, mode=0755)
         except OSError, e:
             msg = "%s: %s %s: %s" % ("Error making cache directory",
                                      dpath, "error was", e)
-            raise Errors.RepoError, msg
+            raise Errors.RepoError(msg, repo=self)
 
     def dirSetup(self):
         """make the necessary dirs, if possible, raise on failure"""
@@ -561,7 +729,7 @@ class YumRepository(Repository, config.RepoConf):
         cookie = self.cachedir + '/' + self.metadata_cookie_fn
         self.setAttribute('_dir_setup_metadata_cookie', cookie)
 
-        for dir in [self.cachedir, self.pkgdir]:
+        for dir in [self.cachedir, self.cachedir + '/gen', self.pkgdir]:
             self._dirSetupMkdir_p(dir)
 
         # persistdir is really root-only but try the make anyway and just
@@ -714,16 +882,16 @@ class YumRepository(Repository, config.RepoConf):
             local = self.metalink_filename + '.tmp'
             if not self._metalinkCurrent():
                 url = misc.to_utf8(self.metalink)
-                ugopts = self._default_grabopts()
+                ugopts = self._default_grabopts(cache=self.http_caching=='all')
                 try:
                     ug = URLGrabber(progress_obj = self.callback, **ugopts)
-                    result = ug.urlgrab(url, local, text=self.id + "/metalink")
+                    result = ug.urlgrab(url, local, text="%s/metalink" % self.ui_id)
 
-                except urlgrabber.grabber.URLGrabError, e:
+                except URLGrabError, e:
                     if not os.path.exists(self.metalink_filename):
                         msg = ("Cannot retrieve metalink for repository: %s. "
-                               "Please verify its path and try again" % self )
-                        raise Errors.RepoError, msg
+                               "Please verify its path and try again" % self.ui_id )
+                        raise Errors.RepoError(msg, repo=self)
                     #  Now, we have an old usable metalink, so we can't move to
                     # a newer repomd.xml ... or checksums won't match.
                     print "Could not get metalink %s error was\n%s: %s" % (url, e.args[0], misc.to_unicode(e.args[1]))                    
@@ -749,9 +917,22 @@ class YumRepository(Repository, config.RepoConf):
                                                               value),
                              fdel=lambda self: setattr(self, "_metalink", None))
 
+    def _all_urls_are_files(self, url):
+        if url:
+            return url.startswith("/") or url.startswith("file:")
+
+        if not self.urls: # WTF ... but whatever.
+            return False
+
+        # Not an explicit url ... so make sure all mirrors/etc. are file://
+        for url in self.urls:
+            if not self._all_urls_are_files(url):
+                return False
+        return True
+
     def _getFile(self, url=None, relative=None, local=None, start=None, end=None,
             copy_local=None, checkfunc=None, text=None, reget='simple', 
-            cache=True, size=None):
+            cache=True, size=None, **kwargs):
         """retrieve file from the mirrorgroup for the repo
            relative to local, optionally get range from
            start to end, also optionally retrieve from a specific baseurl"""
@@ -767,18 +948,16 @@ class YumRepository(Repository, config.RepoConf):
             copy_local = self.copy_local
 
         if local is None or relative is None:
-            raise Errors.RepoError, \
-                  "get request for Repo %s, gave no source or dest" % self.id
+            raise Errors.RepoError("get request for Repo %s, gave no source or dest" % self.ui_id,
+                                   repo=self)
 
         if self.cache == 1:
             if os.path.exists(local): # FIXME - we should figure out a way
                 return local          # to run the checkfunc from here
 
             else: # ain't there - raise
-                raise Errors.RepoError, \
-                    "Caching enabled but no local cache of %s from %s" % (local,
-
-                           self)
+                raise Errors.RepoError("Caching enabled but no local cache of %s from %s" % (local, self.ui_id),
+                                       repo=self)
 
         if url:
             (scheme, netloc, path, query, fragid) = urlparse.urlsplit(url)
@@ -796,6 +975,16 @@ class YumRepository(Repository, config.RepoConf):
             except Errors.MediaError, e:
                 verbose_logger.log(logginglevels.DEBUG_2, "Error getting package from media; falling back to url %s" %(e,))
 
+        if size and (copy_local or not self._all_urls_are_files(url)):
+            dirstat = os.statvfs(os.path.dirname(local))
+            avail = dirstat.f_bavail * dirstat.f_bsize
+            if avail < long(size):
+                raise Errors.RepoError(_('''\
+Insufficient space in download directory %s
+    * free   %s
+    * needed %s'''
+                ) % (os.path.dirname(local), format_number(avail), format_number(long(size))), repo=self)
+
         if url and scheme != "media":
             ugopts = self._default_grabopts(cache=cache)
             ug = URLGrabber(progress_obj = self.callback,
@@ -815,15 +1004,9 @@ class YumRepository(Repository, config.RepoConf):
                                     range=(start, end),
                                     )
             except URLGrabError, e:
-                errstr = "failed to retrieve %s from %s\nerror was %s" % (relative, self.id, e)
-                if self.mirrorurls:
-                    errstr +="\n  You could try running: yum clean expire-cache"
-                    errstr +="\n  To get a new set of mirrors."
-                if e.errno == 256:
-                    raise Errors.NoMoreMirrorsRepoError, errstr
-                else:
-                    raise Errors.RepoError, errstr
-
+                self._del_dl_file(local, size)
+                errstr = "failed to retrieve %s from %s\nerror was %s" % (relative, self, e)
+                raise Errors.RepoError(errstr, repo=self)
 
         else:
             headers = tuple(self.__headersListFromDict(cache=cache))
@@ -835,19 +1018,19 @@ class YumRepository(Repository, config.RepoConf):
                                            reget = reget,
                                            checkfunc=checkfunc,
                                            http_headers=headers,
-                                           size=size
+                                           size=size,
+                                           **kwargs
                                            )
             except URLGrabError, e:
-                errstr = "failure: %s from %s: %s" % (relative, self.id, e)
-                if e.errno == 256:
-                    raise Errors.NoMoreMirrorsRepoError, errstr
-                else:
-                    raise Errors.RepoError, errstr
+                self._del_dl_file(local, size)
+                errstr = "failure: %s from %s: %s" % (relative, self, e)
+                errors = getattr(e, 'errors', None)
+                raise Errors.NoMoreMirrorsRepoError(errstr, errors, repo=self)
 
         return result
     __get = _getFile
 
-    def getPackage(self, package, checkfunc=None, text=None, cache=True):
+    def getPackage(self, package, checkfunc=None, text=None, cache=True, **kwargs):
         remote = package.relativepath
         local = package.localPkg()
         basepath = package.basepath
@@ -857,15 +1040,30 @@ class YumRepository(Repository, config.RepoConf):
                 return local
             misc.unlink_f(local)
 
-        return self._getFile(url=basepath,
+        if checkfunc is None:
+            def checkfunc(obj):
+                if not package.verifyLocalPkg():
+                    misc.unlink_f(local)
+                    raise URLGrabError(-1, _('Package does not match intended download.'))
+
+        ret = self._getFile(url=basepath,
                         relative=remote,
                         local=local,
                         checkfunc=checkfunc,
                         text=text,
                         cache=cache,
                         size=package.size,
+                        **kwargs
                         )
 
+        if not kwargs.get('async') and not package.verifyLocalPkg():
+            # Don't return as "success" when bad.
+            msg = "Downloaded package %s, from %s, but it was invalid."
+            msg = msg % (package, package.repo.id)
+            raise Errors.RepoError(msg, repo=self)
+
+        return ret
+
     def getHeader(self, package, checkfunc = None, reget = 'simple',
             cache = True):
 
@@ -894,19 +1092,16 @@ class YumRepository(Repository, config.RepoConf):
 
         mC_def = self.withinCacheAge(self.metadata_cookie, self.metadata_expire)
         if not mC_def: # Normal path...
-            self._metadataCurrent = mC_def
             return mC_def
 
         # Edge cases, both repomd.xml and metalink (if used). Must exist.
         repomdfn = self.cachedir + '/' + 'repomd.xml'
         if not os.path.exists(repomdfn):
-            self._metadataCurrent = False
             return False
 
         self._hack_mirrorlist_for_anaconda()
         mlfn = self.cachedir + '/' + 'metalink.xml'
         if self.metalink and not os.path.exists(mlfn):
-            self._metadataCurrent = False
             return False
 
         self._metadataCurrent = True
@@ -921,7 +1116,8 @@ class YumRepository(Repository, config.RepoConf):
             return self._metadataCurrent
 
         if self.cache and not os.path.exists(self.metalink_filename):
-            raise Errors.RepoError, 'Cannot find metalink.xml file for %s' %self
+            raise Errors.RepoError('Cannot find metalink.xml file for %s' %self,
+                                   repo=self)
 
         if self.cache:
             self._metadataCurrent = True
@@ -933,7 +1129,7 @@ class YumRepository(Repository, config.RepoConf):
             self._metadataCurrent = False
         return self._metadataCurrent
 
-    def withinCacheAge(self, myfile, expiration_time):
+    def withinCacheAge(self, myfile, expiration_time, expire_req_filter=True):
         """check if any file is older than a certain amount of time. Used for
            the cachecookie and the mirrorlist
            return True if w/i the expiration time limit
@@ -943,6 +1139,24 @@ class YumRepository(Repository, config.RepoConf):
            file. If any of them are newer then invalidate the cache
            """
 
+        # Never/write means we just skip this...
+        if (expire_req_filter and hasattr(self, '_metadata_cache_req') and
+            self._metadata_cache_req.startswith("read-only:") and
+            self.metadata_expire_filter.startswith("read-only:")):
+
+            cache_filt = self.metadata_expire_filter[len("read-only:"):]
+            cache_req  = self._metadata_cache_req[len("read-only:"):]
+
+            if cache_filt == 'future':
+                assert cache_req in ('past', 'present', 'future')
+                expiration_time = -1
+            if cache_filt == 'present':
+                if cache_req in ('past', 'present'):
+                    expiration_time = -1
+            if cache_filt == 'past':
+                if cache_req == 'past':
+                    expiration_time = -1
+
         # -1 is special and should never get refreshed
         if expiration_time == -1 and os.path.exists(myfile):
             return True
@@ -955,6 +1169,9 @@ class YumRepository(Repository, config.RepoConf):
             elif cookie_info[8] > time.time():
                 val = False
 
+            if not self.check_config_file_age:
+                return val
+
             # make sure none of our config files for this repo are newer than
             # us
             if cookie_info[8] < int(self.repo_config_age):
@@ -991,7 +1208,8 @@ class YumRepository(Repository, config.RepoConf):
     def _cachingRepoXML(self, local):
         """ Should we cache the current repomd.xml """
         if self.cache and not os.path.exists(local):
-            raise Errors.RepoError, 'Cannot find repomd.xml file for %s' % self
+            raise Errors.RepoError('Cannot find repomd.xml file for %s' % self.ui_id,
+                                   repo=self)
         if self.cache or self.metadataCurrent():
             return True
         return False
@@ -1019,8 +1237,9 @@ class YumRepository(Repository, config.RepoConf):
             misc.unlink_f(tfname)
             if grab_can_fail:
                 return None
-            raise Errors.RepoError, 'Error downloading file %s: %s' % (local, e)
-        except (Errors.NoMoreMirrorsRepoError, Errors.RepoError):
+            raise Errors.RepoError('Error downloading file %s: %s' % (local, e),
+                                   repo=self)
+        except Errors.RepoError:
             misc.unlink_f(tfname)
             if grab_can_fail:
                 return None
